' Sleep steam train whistle
' Started....07-12-18
' Microcontroller used: Microchip Technology 12F617
' microchip.com
' PicBasic Pro Code: micro-Engineering Labs, Inc.
' melabs.com
'-------Program Desciption--------
' After about 12 seconds when power is initially applied to the whistle circuit  
'the current drops to practcally zero. If the whistle button is pressed the power comes on
'and in 300ms (time for the MPU to start) the whistle sounds and the timer is reset. 
'When the whistle button is pressed again the whistle sounds in 5ms and the timer is reset. 
'If the whistle button is not pressed for 12 sec then the micro goes into the sleep mode 
'drawing practically zero current.When power is first applied a mute signal is generated to
'eliminate any speaker clicks

 #CONFIG
 __CONFIG   _CP_OFF & _BOR_OFF & _MCLRE_ON & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT & _IOSCFS_4MHZ & _WRT_OFF
  #ENDCONFIG
  ASM
  bsf		STATUS,RP0	; bank 1
        movlw   0x00      			 ; set oscillator to factory calibrated frequency 
        movwf   OSCTUNE
	bcf		STATUS,RP0
	ENDASM
  Define OSC 4
 CMCON0.7 = 0    ' comparitor off
 VRCON.7 = 0'comparitor voltage ref off
ADCON0.0 = 0  'ADC off  
 ANSEL = %00000000 'all digital 
 on interrupt goto zero 
 INTCON = %10010000' interrupt on GP2
 
OPTION_REG.6 = 0 'interrupt on falling edge of GP2
OPTION_REG.7 = 1 'pull ups off

 
 TRISIO = %11001110 'all ports inputs except GP4(power), GP0 (whistle) and GP5 mute

GPIO.4 = 0 'power off
GPIO.0 = 1'whistle off 
GPIO.5 = 0 'mute off

a var word 
 a = 1
 P var word
 P = 5
 
Start:

P = 5
for a = 1 to 1000
pause 12  '
next a ' 12 sec delay 
GPIO.5 = 1 '*mute on 
P = 300
GPIO.4 = 0  'power off
pause 100' delay to eliminate switch off speaker click
GPIO.5 = 0  'mute off

TRISIO.0 = 1  'GP0 input to reduce current, 10K resistor to supply is the
'equivalent to being connected to an off micro

nap 10

goto Start '*
disable 
zero: 
TRISIO.0 = 0' GP0 output
GPIO.0 = 1 'whistle off
a = 1 
GPIO.5 = 1 'mute on
GPIO.4 = 1 'power on
pause P 'pause P to allow MPU to settle in on state
GPIO.5 = 0 'mute off
GPIO.0 = 0' start whistle
Pause 10 '10ms pulse
GPIO.0 = 1' whistle off

 INTCON.1 = 0 'clear interrupt flag
 RESUME ' go back 
 enable 
